;*********************************************************************************************************
;* TEST SENSORS INFRARROIJOS_IR CNY70							     Lleonard Garca i Llop*
;*********************************************************************************************************
; 1.-Per estalviar energa es pot collocar un led bicolor en lloc del motor.
; 2.-BRIDGE MOTORS (4 semibridges amb SN754410NE)
;    Bridge= pont  s una connexi en que de forma de H (el pal vertical de la dreta,
;    el tram mig horitzontal i el pal vertical de l'esquerra).
;    A la dreta est el Semibridge_a, en funci d'un 0  1, connecta a + o - el born_a del motor.
;    A la dreta est el Semibridge_b, en funci d'un 0  1, connecta a + o - el born_b del motor.
;    Semi_bridge_a    Semi_bridge_a	      Motor						Leds
;        0 (-)			0 (-)		ATURAT					APAGAT
;        1 (+)			0 (-)		CCWS (motor gira en sentit invers)	Verd
;        0 (-)			1 (+)		CWS (motor gira envant)			Vermell
;        1 (+)			1 (+)		ATURAT					APAGAT
; 3.-El sistema t un defecte. Si gira envant i immediatament es dona instrucci de girar enrera,t el mateix
;    efecte que un curtcircuit. Es recomana afegir un breu retard i fer que el temps amortitzi
;    l'energia acumulada en el motor en moviment.
; 4.-CIRCUIT IMPRS QUE UTILITZA PICAXE 14M2
;					 ******************
;	 	               +V  * 1		   14 *  GND
;	 	           SI /C.5 * 2		   13 *  B.0 /SO	bridge M2 (canviar jumper)
;	 	   bot_BAIXAR C.4 * 3		   12 *  B.1	IR SENSOR
;	 	   bot_PUJAR  C.3 * 4		   11 *  B.2	LED INPERIOR
; 		   bridge M2   C.2 * 5		   10 *  B.3	LED SUFERIOR
;	 	   bridge M1   C.1 * 6		    9 *  B.4     	SENSOR_SUPERIOR
;              bridge M1   C.0 * 7		    8 *  B.5	SENSOR INFERIOR
;  					 ******************
pause 1000; permet programaci segura durant 1 segon desprs de connectar
;*********************************************************************************************************
;*********************************************************************************************************
;CONFIGURACIONS DEL HARDWARE
;setint %00000000,%00000000 	; Configuraci de les interrupcions.
let dirsC=%00001011 		; Definicions del port_C (1=sortida 0=entrada).
let dirsB=%00001101 		; Definicions del port_B (1=sortida 0=entrada).
symbol bridge_M1a=C.0		; SORTIDA.Semi-bridge_a del motor_M1.
symbol bridge_M1b=C.1		; SORTIDA.Semi-bridge_b del motor_M1.
symbol bridge_M2a=C.2		; SORTIDA.Semi-bridge_a del motor_M2.
symbol bridge_M2b=B.0		; SORTIDA.Semi-bridge_b del motor_M2.
symbol PUJAR=C.3			; ENTRADA. Bot de pujar.
symbol BAIXAR=C.4			; ENTRADA. Bot de baixar.
symbol sensor=B.1			; ENTRADA. Sensor infrarroig TSOP4838.
symbol led_inferior=B.2		; SORTIDA. Led emisor1.
symbol led_superior=B.3 	; SORTIDA. Led emisor2.
symbol fiCursa_inferior=B.5	; ENTRADA. Fototransistor_1
symbol fiCursa_superior=B.4	; ENTRADA. Fototransistor_2
symbol botPujar=pinC.3
symbol botBaixar=pinC.4
;DEFINICI DE CONSTANTS.
;DEFINICI DE VARIABLES.
symbol codi_IR=b0
symbol estat1=b1
symbol estat2=b2
;PROGRAMA INICIAL
low bridge_M1a, bridge_M1b, bridge_M2a, bridge_M2b	; inicialment motors aturats.	
;PROGRAMA PRINCIPAL O REITERATIU
main:

if botBaixar=1 then call baixar1
if botPujar=1 then call pujar1


if estat1=1 then call testsuperior
if estat1=2 then call testinferior


irin [200,time_out],B.1,b0
call aturar1
if b0=13 then call pujar1
if b0=22 then call baixar1
time_out:
goto main


testinferior:
high led_inferior
readadc fiCursa_inferior,b5
low led_inferior
if b5>16 then call aturar1
return	

testsuperior:
high led_superior
readadc fiCursa_superior,b5
low led_superior
if b5>16 then call aturar1
return


pujar1:
call aturar1
pause 1
low bridge_M1a
high bridge_M1b
let estat1=1
return

baixar1:
call aturar1
pause 1
high bridge_M1a
low bridge_M1b
let estat1=2
return

aturar1:
low bridge_M1b
low bridge_M1a
let estat1=0
return

pujar2:
call aturar2
;pause 100
low bridge_M2a
high bridge_M2b
let estat2=1
return

baixar2:
call aturar2
;pause 100
high bridge_M2a
low bridge_M2b
let estat2=2
return

aturar2:
low bridge_M2b
low bridge_M2a
let estat2=0
return

